unit piKeyPass;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
  piAbout='(C) 2000, Programmed Integration';
  piVersion='1.01';
  FullDay: array[0..6] of string=('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');

type
  TpiAbout = String[32];
  TpiVersion = String[4];

  TpiKeyPass = class(TComponent)
  private
    { Private declarations }
    FAbout: TpiAbout;
    FDate: TDateTime;
    FKey: string;
    FResultKey: string;
    FVersion: TpiVersion;
    procedure SetVersion(const Value: TpiVersion);
    procedure SetAbout(const Value: TpiAbout);
    procedure SetKey(Value: string);
    procedure SetFullYear;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
	 procedure execute;
  published
    { Published declarations }
    property About: TpiAbout read FAbout write SetAbout;
    property Date: TDateTime read FDate write FDate;
    property Key: string read FKey write SetKey ;
    property ResultKey: string read FResultKey write FResultKey;
    property Version: TpiVersion read FVersion write SetVersion;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PI Components', [TpiKeyPass]);
end;

procedure TpiKeypass.execute;
var
   useday, usemonth, useyear: word;
   decrypt: string;
   usevalue1, usevalue2: integer;
   resultvalue: integer;
   addkey: string;
   resultkey: string;
   forcount1: integer;
   usefullday: string;

	function padzero(usenumber: word; usedigit: integer) : string;
   var
      forcount1: integer;
	begin
   	Result:=IntToStr(usenumber);
      if (length(IntToStr(usenumber)))<usedigit then
         for forcount1:=Length(IntToStr(usenumber)) to usedigit-1 do
            begin
               Result:='0'+Result;
            end;
	end;
begin
	decodedate(fdate, useyear, usemonth, useday);
   decrypt:=padzero(useday,2)+padzero(usemonth,2)+padzero(useday,2)+padzero(usemonth,2)+padzero(useyear,4)+padzero(useday,2)+padzero(usemonth,2);
   usefullday:=FullDay[(dayofweek(fDate)-1)];
   for forcount1:=1 to Length(usefullday) do
   	decrypt[forcount1]:=char((((((Ord(decrypt[forcount1])+Ord(usefullday[forcount1])))mod 10)+48)));
   FResultkey:='';
   for forcount1:=1 to 8 do
      begin
         usevalue1:=strtoint(Copy(key, forcount1*2-1, 2));
         usevalue2:=strtoint(Copy(decrypt, forcount1*2-1, 2));
         resultvalue:=usevalue1+usevalue2;
         addkey:=char(((resultvalue mod 26)+65));
         Fresultkey:=Fresultkey+addkey;
      end;
end;

constructor TpiKeypass.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   setfullyear;
   FAbout:=piAbout;
   FVersion:=piVersion;
   FDate:=now;
   Fkey:='';
   FResultkey:='';
end;

destructor TpiKeypass.Destroy;
begin
   inherited Destroy;
end;

procedure TpiKeyPass.SetVersion(const Value: TpiVersion);
begin
  FVersion:=FVersion;
end;

procedure TpiKeyPass.SetAbout(const Value: TpiAbout);
begin
  FAbout:=FAbout;
end;

procedure TpiKeyPass.SetKey(Value: string);
var
   forcount1: integer;
begin
	if (length(value)<16) then
		raise Exception.create('Key must consist of 16 numbers');
	if (length(value)>16) then
		raise Exception.create('Key must consist of 16 numbers');
   for forcount1:=1 to 16 do
   	begin
      	if (pos(value[forcount1], '0123456789')=0) then
         	begin
      			raise Exception.create('Key must consist of numbers only');
               abort;
            end;
      end;
   FKey:=Value;
end;

procedure TpiKeyPass.SetFullYear;
var
  i: integer;
begin
	if pos('YYYY',uppercase(ShortDateFormat))=0 then
   	begin
      	i:=pos('YY',uppercase(ShortDateFormat));
        	ShortDateFormat:=copy(ShortDateFormat,1,i-1)+'YYYY'+
        		copy(ShortDateFormat,i+2,50);
      end;
end;

end.
